---
title: EVM Memory Layout in Solidity
version: 0.8.24
description: Example of EVM memory in Solidity
keywords: [data, evm, memory, yul, assembly]
---

Examples of

- Reading and writing to memory with `assembly`
- Memory layout in Solidity of different data types
- Memory management for external calls

```solidity
{{{YulMem}}}
```

### References

[Solidity document](https://docs.soliditylang.org/en/latest/internals/layout_in_memory.html)

[EVM Codes](https://www.evm.codes/)
